import stamp.core.*;
import stamp.math.*;
import stamp.util.text.*;

/**
 * Test class for UnsignedIntMath class.
 *
 * @author Peter Verkaik (peterverkaik@boselectro.nl)
 * @version 1.2 December 21, 2005
 */

public class UnsignedIntMath_test {

  static void main() {
    int d,f;
    Format.printf("Test program for UnsignedIntMath class\n\n");

    Format.printf("test  123/678 = 11889/65536 = 1814/10000\n");
    f = UnsignedIntMath.frac(123,678);
    Format.printf("      results   %5u/65536",f);
    d = UnsignedIntMath.frac2dec(f);
    Format.printf("   %4d/10000\n",d);

    Format.printf("test -123/678 = 11889/65536 = 1814/10000\n");
    f = UnsignedIntMath.frac(-123,678);
    Format.printf("      results   %5u/65536",f);
    d = UnsignedIntMath.frac2dec(f);
    Format.printf("   %4d/10000\n",d);

    Format.printf("test 0x0123/0x0678 = 11516/65536 = 1757/10000\n");
    f = UnsignedIntMath.ufrac(0x0123,0x0678);
    Format.printf("           results   %5u/65536",f);
    d = UnsignedIntMath.frac2dec(f);
    Format.printf("   %4d/10000\n",d);

    Format.printf("test 0x9123/0x0678 = 22 + 28612/65536 = 22 + 4365/10000\n");
    f = UnsignedIntMath.udiv((short)0x9123,0x0678);
    Format.printf("           results   %2u",f);
    f = UnsignedIntMath.ufrac((short)0x9123,0x0678);
    Format.printf("   %5u/65536",f);
    d = UnsignedIntMath.frac2dec(f);
    Format.printf("        %4d/10000\n",d);

    Format.printf("test 0x0123/0xABCD =   433/65536 =   66/10000\n");
    f = UnsignedIntMath.ufrac(0x0123,(short)0xABCD);
    Format.printf("           results   %5u/65536",f);
    d = UnsignedIntMath.frac2dec(f);
    Format.printf("   %4d/10000\n",d);

    Format.printf("test 0x9123/0xABCD = 55364/65536 = 8447/10000\n");
    f = UnsignedIntMath.ufrac((short)0x9123,(short)0xABCD);
    Format.printf("           results   %5u/65536",f);
    d = UnsignedIntMath.frac2dec(f);
    Format.printf("   %4d/10000\n",d);

    Format.printf("usqrt(x)\n");
    for (int i=0; i<256; i++) {
      Format.printf("%6u ",i*i+3);
      int value = UnsignedIntMath.usqrt(i*i+3);
      Format.printf("%3u.",value>>>8); //display integer plus decimal point
      Format.printf("%02u\n",((value&0xFF)*100+128)/256); //display 2 decimals
    }

    Format.printf("Program has finished\n");
    while (true) {
    }
  }

}