import stamp.math.*;
import stamp.util.text.*;

/**
 * Test prgram for floating point class f3.
 *
 * f3 value floating point format
 *
 *     +-+----------+-+----+
 *     |s|mmmmmmmmmm|x|eeee|
 *     +-+----------+-+----+
 *
 *     s = mantissa sign (1 bit)
 *     m = mantissa      (10 bits)
 *     x = exponent sign (1 bit)
 *     e = exponent      (4 bits)
 *
 * The signed range is from -0.999E+15 to +0.999E+15 which should be sufficient.
 * Near zero, the smallest values are -0.001E-16 and +0.001E-16 which also should be sufficient.
 * The f3 value zero 0.000E+00 equals the integer value zero (binary null).
 *
 * @author Peter Verkaik (peterverkaik@boselectro.nl)
 * @version 1.0 January 4, 2006
 */

public class f3_test {

  static final int ADD=0;
  static final int SUB=1;
  static final int MUL=2;
  static final int DIV=3;

  static void print(int type, int a, int b) {
    int c=0;
    switch (type) {
      case ADD: c = f3.add(a,b);
                Format.printf("add:  ");
                break;
      case SUB: c = f3.sub(a,b);
                Format.printf("sub:  ");
                break;
      case MUL: c = f3.mul(a,b);
                Format.printf("mul:  ");
                break;
      case DIV: c = f3.div(a,b);
                Format.printf("div:  ");
                break;
    }
    Format.printf("a=");
    f3.printf(a);
    Format.printf("   ");
    Format.printf("b=");
    f3.printf(b);
    Format.printf("   ");
    Format.printf("c=");
    f3.printf(c);
    Format.printf("\n");
  }

  static void main() {
    int a,b;
    Format.printf("Class f3 test program\n");

    a = f3.PI;
    b = f3.E;

    print(ADD,a,b);
    print(SUB,a,b);
    print(MUL,a,b);
    print(DIV,a,b);

    Format.printf("Program finished\n");
    while (true) {
    }
  }

}
